#ifndef _GET_INTO_SPACE_OPTION_H_
#define _GET_INTO_SPACE_OPTION_H_

#include "PassiveOption.h"

const int GET_INTO_SPACE_OPTION_ID = 709;


/**
  Diese Klasse steht f\"ur den Wunsch sich freizulaufen. Dieser Wunsch
  bekommt eine hohe Aktivierung, wenn der Spieler den Ball nicht am schnellsten
  bzgl. seiner Teamkameraden erreichen kann, aber sich in unmittelbarer N\"ahe
  zu dem Spieler befindet, der den Ball am schnellsten erreichen kann. Bei
  Auswahl dieses Wunsches l\"auft sich der Spieler frei, so da\3 er gut von
  diesem Spieler angespielt werden kann.

  {\small {\bf Quelltext}

  [\URL[Header]{src/GetIntoSpaceOption.h} | [\URL[Implementierung]{src/GetIntoSpaceOption.cc}]

  {\bf CVS Informationen zum Interface}
  \begin{verbatim}
  **************************************************
  *
  * Aktueller Stand
  *
  *   $RCSfile: GetIntoSpaceOption.h,v $
  *   $Revision: 1.7 $
  *   $Date: 1998/08/14 13:20:36 $
  *   $Author: myritz $ 
  *
  **************************************************
  \end{verbatim} }*/
class GetIntoSpaceOption : public PassiveOption
{
public:
  /** Erzeugt eine GetIntoSpaceOption. */
  GetIntoSpaceOption();
  
  /** Erzeugt einen Plan zur Umsetzung der Absicht.  */
  Plan generatePlan() const;

  /** Beschreibung als String fuer die Ausgabe auf einem Terminal. */
  virtual String toString() const;

  /** Legt eine Kopie des Objekts auf dem Heap an und liefert einen Zeiger
      darauf zurueck. Diese Methode muss fuer JEDE Unterklasse neu definiert 
      werden. */
  virtual StorableObject* copy() const;
  
private:
  
  /** Der Grundnutzen des Wunsches. Dieser Teil der Nutzenberechnung ist nur 
    vom Weltmodell abhaengig.
    @return Ein Wert zwischen MAX_UTILITY und MIN_UTILITY. */
  int baseUtility() const;
  
};

#endif


